# simple hash to stop people seeing the answers
def hash(text):
	hash = 0
	for chr in text:
		hash = ((hash << 5) - hash) + ord(chr)
	return hash


# check that the filename is a valid URL
def isValidURL(text):
	valid = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-._~:/?#[]@!$&'()*+,;="
	if text > "" and text not in ("header.txt", "main.py"):
		OK = True
		for char in text:
			if char not in valid:
				OK = False
		return OK
	else:
		return False


# lists of questions and choices
# each question/paragraph is an item in the list
# with each choice being a sub-list within that
question = [[]]
option = [[]]

# collect questions / paragraphs
heading = input("What is the name of this quiz? ").replace("'", "&apos;")
print(
    "\nEnter the text of one question/paragraph at a time.\nUse [] to indicate where the choices will be inserted.\nEnter nothing (i.e. press Enter only) to finish."
)
# set to True when final question is empty
finished = False
qu_no = 0
while not finished:
	# ask for the next question
	qu_text = input("\n" + str(qu_no + 1) + ". ")
	if qu_text > "":
		# split the question at the []
		question[qu_no] = qu_text.split("[]")
		# there is one lesson gap than text item
		for gap in question[qu_no][:-1]:
			print("Enter comma-separated choices to come after:\n'" + gap +
			      "'\nPrecede the correct answer with an underscore.")
			options = input()
			options = [i.strip() for i in options.split(",")]
			option[qu_no].append(options)
		option.append([])
		question.append([])
		qu_no += 1
	else:
		finished = True
		# remove the appended items that we don't use
		question.pop()
		option.pop()

# choose a filename
filename = ""
# ensure that the filename is valid
while not isValidURL(filename):
	filename = input("Enter a valid filename: ")

# write the HTML
# copy in the header containing JavaScript, etc.
f = open(filename, "w")
for row in open("header.txt", "r"):
	f.write(row)
# add in the questions
answer = []
f.write("<body>\n<header>\n<h1 id='main'>" + heading + "</h1>\n</header>\n")
# loop through the questions
for qu in range(len(question)):
	line = "<p>"
	for sel in range(len(question[qu])):
		# add the question text
		line += question[qu][sel]
		# add the choices
		if sel < len(question[qu]) - 1:
			line += "<select class='answer'>"
			line += "<option>[not selected]</option>"
			for opt in option[qu][sel]:
				# add the right answer to answer array
				if opt[0] == "_":
					choice = opt[1:]
					# make answer unreadable in the source
					answer.append(hash(choice))
				else:
					choice = opt
				line += "<option>" + choice + "</option>"
			line += "</select>"
	line += "</p>\n"
	# write the question to the file
	f.write(line)
# add the space for the score to appear
f.write("<p id='result'>&nbsp;</p>\n")
# add the Check button
f.write("<input type='button' value='Check' onclick='mark();'>\n")
f.write("<script>\n<!--\n")
# set the title (which is in the header file)
f.write("document.title = '" + heading + "';\n")
# add the answers for the JavaScript to read
f.write("var answer = " + str(answer) + ";\n")
# change background of option to white when changed
f.write("whiten();\n")
# close the remainder of the tags
f.write("//-->\n</script>\n</body>\n</html>")
f.close()

# - You might find this easier to use locally - choose
#   "Download as zip" from the top of the Files panel.
# - Pages generated validate as HTML5.
# - To change colours, etc., edit the <style> section
#   in header.txt.
# - Currently the score is reduced by 10% with each
#   attempt on line 42 of header.txt.