# Calculator Example

from Tkinter import *

# initialise variables
total = 0
digits = "0"
operator = "+"

# define procedures
def clear():
    global total
    global digits
    total = 0
    digits = "0"
    answer.set(str(total))
    i.set(digits)

def calculate(symbol):
    global total
    global digits
    global operator
    if symbol == "=" and operator == "=":
        total = int(digits)
    elif operator == "-":
        total = total - int(digits)
    else:
        total = total + int(digits)
    digits = "0"
    operator = symbol
    answer.set(total)
    i.set(digits)

def click(num):
    global digits
    if digits == "0":
        digits = str(num)
    elif len(digits) < 3:
        digits += str(num)
    i.set(digits)

# create the window
calculator = Tk()
calculator.resizable(width=FALSE, height=FALSE)
calculator.title("Calculator")

# create input display label
i = StringVar()
iDisplay = Label(calculator, textvariable=i, fg="black", bg="grey", width=26, font=("Helvetica", 9), anchor=E).grid(row=0, column=0, columnspan=4)
i.set("0")

# create main display label
answer = StringVar()
main = Label(calculator, textvariable=answer, fg="black", bg="grey", width=13, font=("Helvetica", 18), anchor=E).grid(row=1, column=0, columnspan=4)
answer.set("0")

# create buttons using a grid
button7 = Button(calculator, text="7", fg="blue", command=lambda: click(7), width=3, font=("Helvetica", 16)).grid(row=2, column=0)
button8 = Button(calculator, text="8", fg="blue", command=lambda: click(8), width=3, font=("Helvetica", 16)).grid(row=2, column=1)
button9 = Button(calculator, text="9", fg="blue", command=lambda: click(9), width=3, font=("Helvetica", 16)).grid(row=2, column=2)
button4 = Button(calculator, text="4", fg="blue", command=lambda: click(4), width=3, font=("Helvetica", 16)).grid(row=3, column=0)
button5 = Button(calculator, text="5", fg="blue", command=lambda: click(5), width=3, font=("Helvetica", 16)).grid(row=3, column=1)
button6 = Button(calculator, text="6", fg="blue", command=lambda: click(6), width=3, font=("Helvetica", 16)).grid(row=3, column=2)
button1 = Button(calculator, text="1", fg="blue", command=lambda: click(1), width=3, font=("Helvetica", 16)).grid(row=4, column=0)
button2 = Button(calculator, text="2", fg="blue", command=lambda: click(2), width=3, font=("Helvetica", 16)).grid(row=4, column=1)
button3 = Button(calculator, text="3", fg="blue", command=lambda: click(3), width=3, font=("Helvetica", 16)).grid(row=4, column=2)
button0 = Button(calculator, text="0", fg="blue", command=lambda: click(0), width=11, font=("Helvetica", 16)).grid(row=5, column=0, columnspan=3)
buttonPlus = Button(calculator, text="+", fg="green", command=lambda: calculate("+"), width=3, font=("Helvetica", 16)).grid(row=2, column=3)
buttonMinus = Button(calculator, text="-", fg="green", command=lambda: calculate("-"), width=3, font=("Helvetica", 16)).grid(row=3, column=3)
buttonEquals = Button(calculator, text="=", fg="green", command=lambda: calculate("="), width=3, font=("Helvetica", 16)).grid(row=4, column=3)
buttonClear = Button(calculator, text="C", fg="red", command=clear, width=3, font=("Helvetica", 16)).grid(row=5, column=3)

# start the event loop
calculator.mainloop()
